// SimpleCtrlScriptStart {invalid}
const string sReference="ProcessInput.Data.sensorStatus:_online.._value";
const int cIntCommand=8;  // Reset Sensors SameLevel
const int cIntTime=10;    // 10 seconds of delay after a reset action
int lastResetOffset;  // Last RESET done
int iNumberOfResets;
int initialActivationTime;
main()
{
dyn_errClass err;
dyn_string deviceToWatch,dsReferenceToWatch;
string myDpe,myCompleteDpe;
dyn_string exceptionInfo;
   
  // Ini last reset time (seconds)
  lastResetOffset=0;
  iNumberOfResets=0;
  initialActivationTime=period(getCurrentTime());
  
  // Ini All devices to look after
  deviceToWatch=makeDynString("CNGS_2B00_TT050","CNGS_2B01_TT050","CNGS_2B02_TT050","CNGS_2B03_TT050","CNGS_2B04_TT050",
							  "CNGS_2B05_TT050","CNGS_2B06_TT050","CNGS_2B07_TT050","CNGS_2B08_TT050","CNGS_2B09_TT050",							  "CNGS_2B10_TT050","CNGS_2B11_TT050");
 
  // Convert ALIAS to dpe (+"ProcessInput.Data.sensorStatus:_online.._value")
  // string myDpe="dist_1:un-PCGW31__M-AppliTest-TT-00001.ProcessInput.Data.sensorStatus:_online.._value";
  for (int i=1;i<=dynlen(deviceToWatch);i++)
  {
      myDpe=unGenericDpFunctions_dpAliasToName(deviceToWatch[i]);
      myCompleteDpe=myDpe+sReference;
      // DebugN("myDpe="+myDpe);
      // DebugN("myCompleteDpe=" + myCompleteDpe);
  
      //DpConnect to those devices (callback function)
      if( !dpExists( myCompleteDpe))
        {
          DebugN("EXCEPTION: Dpe does not exists: ",myCompleteDpe);
          return;
        }
      else
        dynAppend(dsReferenceToWatch,myCompleteDpe);
    } 
  DebugN("Featured by Quique June 2009");
  DebugN("AUTO RESET Feature ACTIVATED @ " +(string) getCurrentTime());
  unMessageText_send(getSystemName(), myManNum(), getSystemName()+","+myManNum()+","+getHostname()+","+getUserName(), "user","*", "INFO",
		      "AUTO_RESET feature ACTIVATED @ "+(string)getCurrentTime(),exceptionInfo);

  DebugN("deviceToWatch",deviceToWatch);      
  dpConnect("callback_IOStatChange", dsReferenceToWatch);

}


callback_IOStatChange(dyn_string dsRefSource, dyn_uint dUintValues)      // dpSource
{
  dyn_string dsRESETInfos, exceptionInfo;
  string sAgentName,sAgentNumber;
  string sAlias,sDpe;
  string sAgentFromResetAction, sAgentRef;
  int possibleReset, iOffsetTime;    
  
  // DebugN("FUNCTION:: callback_IOStatChange()");
  // DebugN("dsRefSource="+dsRefSource);
  // DebugN("dUintValues=",dUintValues);
  
  for (int i=1;i<=dynlen(dsRefSource);i++)
    {
          // Alias
          sDpe=dpSubStr(dsRefSource[i],DPSUB_SYS_DP);
          // DebugN("sDpe="+sDpe);
   
          sAlias=unGenericDpFunctions_getAlias(sDpe);
          // DebugN("sAlias="+sAlias);
  
          sAgentName=cietGenericFunctions_getAgentName(sDpe);
          // DebugN("sAgentName="+sAgentName);
 
          // Compose command instrumentation reset from its opposite agent
          cietGenericFunctions_getResetInfos(dsRefSource[i],dsRESETInfos,exceptionInfo);

          // Print out
          // DebugN("dsRESETInfos["+i+"]=",dsRESETInfos);
  
          sAgentFromResetAction="";
          // Identify the agent of the TT in IOError
          if (dsRESETInfos[ciet_PARAM_RESET_TOPODD_AGENT]== sAgentName)
              sAgentFromResetAction = dsRESETInfos[ciet_PARAM_RESET_TOPEVEN_AGENT];
          else if (dsRESETInfos[ciet_PARAM_RESET_BOTTONODD_AGENT]== sAgentName)
              sAgentFromResetAction = dsRESETInfos[ciet_PARAM_RESET_BOTTONEVEN_AGENT];
          else
             DebugN("WARNING: TT="+sAlias+" in IOError and its agentName="+sAgentName+" not found");
    
          // If IOError present (check odd Number)
          if ((dUintValues[i] % 2) == 1)
            {
             possibleReset=period(getCurrentTime());
             iOffsetTime=possibleReset-lastResetOffset;
             // DebugN("iOffsetTime="+iOffsetTime);
             if (iOffsetTime > cIntTime)
                { 
                 lastResetOffset=period(getCurrentTime());    // seconds prom EPOCH
                 DebugN("Time last Reset="+(string)getCurrentTime());
                 sendCommand(sAgentFromResetAction,sAlias,cIntCommand);                                               
                 return;
                }   
             }
    }  // for all the TT included
}

sendCommand(string sAgentName, string sDeviceName, int iCommand)
{
  string sAgentRef;
  dyn_string exceptionInfo;
  int currentResetTime;
  float averageResetsHour; 
  float diffHours;
      
  // DebugN("FUNCTION: sendCommand(sAgentName="+sAgentName+" ; sDeviceName=",sDeviceName,+")");
  iNumberOfResets=iNumberOfResets+1;
  currentResetTime=period(getCurrentTime());
  
  diffHours=(float)(currentResetTime-initialActivationTime);
  diffHours=diffHours/3600;
  
  if ((currentResetTime-initialActivationTime)>=3600)
    averageResetsHour=(float)iNumberOfResets/diffHours;
  else
    averageResetsHour=iNumberOfResets;
  
  dpSet(dpAliasToName(sAgentName)+"ProcessOutput.Command.command",iCommand);
  
  // Logging
  DebugN("AUTO_RESET n<"+iNumberOfResets+"> <Average="+averageResetsHour+" resets/hour>; AGENT= "+sAgentName+" COMMAND: "+iCommand);
  unMessageText_send(getSystemName(), myManNum(), getSystemName()+","+myManNum()+","+getHostname()+","+getUserName(), "user","*", "INFO",
		      "AUTO_RESET n<"+iNumberOfResets+"> <Average="+averageResetsHour+" resets/hour>; AGENT= "+sAgentName+" COMMAND = "+iCommand+ " triggered by TT="+sDeviceName,exceptionInfo);

}
