/*
@author: Enrique BLANCO (EN/ICE)

Creation Date: 24/04/2009
	
version 1.2
	- Change of the name of the function

External Function : 
	. cietUserlib_Logging
	
Internal Functions :
	unUserlib_SystemAlarmInfo
Purpose: 
This library contains the CIET functions to create Configuration file for the LHCLogging API

Usage: Public

PVSS manager usage: NV

Constraints:
	. PVSS version: 3.6
	. operating system: windows XP & Linux SLC4
	. distributed system: No
*/

//-----------------------------------------------------------------------------------------------------------
// Function: unUserlib_CIET
// 		1st approach to the logging configuration
// 		Initially the simplest possible following the current storage method
// 
cietConfig_LOGGING(string sDpe, string &sN,  string &sD, string &sH, string &sA, string &sE)
{
dyn_string dsParameters, dsSplit;
string sAlias, deviceName, sSystemName, sLocation, sApplication, sDomaine, sNature;
bool bState,bUseDpe, bOK;
int iNum, iLen;
string sDevType;


 	// DebugN("FUNCTION hello:: unUserlib_CIET(sDpe= "+sDpe);	

	sSystemName=getSystemName();
	sH = "ERROR";
	sE = sDpe;

	//remove system name
	unCoreLHCServices_set_SystemName(sDpe, bState, false);			

	if (shapeExists("useDpe"))
		bUseDpe = useDpe.state(0);

	iNum=-1;
	if (shapeExists("Button"))
		iNum=Button.number();
		
	switch(iNum)
		{
		case 0:	// Unicos mode
			//Domain / nature
			deviceName = unGenericDpFunctions_getDpName(sDpe);			
			unGenericDpFunctions_getParameters(deviceName, dsParameters);		
			
			//Location
			dynClear(dsSplit);													
			dsSplit=strsplit(sSystemName,"_");
			if (dynlen(dsSplit)>1)
				sLocation=dsSplit[1];
			else
				sLocation=substr(sSystemName, 0, strlen(sSystemName)-1);

			//Application 
			dynClear(dsSplit);
			dsSplit=strsplit(sDpe,"-");
			if (dynlen(dsSplit)>3)
				sApplication=dsSplit[3];
			else
				sApplication="UNKNOWN";
			
			//Nature
			sDevType=dpTypeName(sDpe);
			

			//Nature
			if(dpExists(sDpe))				
			sDevType=dpTypeName(sDpe);
			
			if(!dpExists(sDpe))			
				{

					DebugN("*** ERROR DPE does not exists -->  sDpe= " + sDpe + "  //  " + "sDevType = " + sDevType);	
				}


			switch(sDevType)
				{
					case "TT":	
						sNature="TT";
						break;
					case "PT": 
						sNature="PT";
						break;
					case "LT":	
						sNature="LT";
						break;
					case "DI":
						sNature="DI";
						break;
					case "EH":					
						sNature="EH";
						break;
					case "EHBS":					
						sNature="EHBS";
						break;
					case "WFIPEvenAgent":				
						sNature="WFIPAgent";
						break;
					case "WFIPOddAgent":				
						sNature="WFIPAgent";
						break;
					case "WFIPSegment":		
						sNature="WFIPSegment";
						break;
					default: 
						DebugN("*** ERROR Nature -->  dpe= " + sDpe+ "type UNKNOWN: <"+sDevType+">");
				}
			// DebugN("NATURE >> deviceName= "+deviceName+" sNature="+sNature+" sLocation="+sLocation+ " sApplication="+sApplication);
			
			//Domain
                         	switch(sDevType)
				{
					// It could multiple domain
					case "TT":
					case "PT":
					case "LT":
					case "EHBS":
					case "EH":
                                              case "DI":
                                                 
                                                // The equipment is allways taken
                                                
                                                sAlias = unGenericDpFunctions_getAlias(deviceName);
                                                dyn_string dsAliasMembers=strsplit(sAlias,"_");                                    
                                                sDomaine = dsAliasMembers[2];
                                                
                                                /*
                                                // case empty
                                                  if  (dsParameters[UN_PARAMETER_DOMAIN] == "")	// Empty domain! (try to put location)	
                                                        {
                                                          // try to get location
                                                          sAlias = unGenericDpFunctions_getAlias(deviceName);
                                                          dyn_string dsAliasMembers=strsplit(sAlias,"_");                                    
                                                          sDomaine = dsAliasMembers[2];
                                                          // DebugN("case empty DOMAIN Type= "+sDevType+" Found alias="+sAlias+" Assigned domain= "+sDomaine);
                                                        }
                                                  else if(strpos(dsParameters[UN_PARAMETER_DOMAIN], ",") >=0) //cas multidomaine	
  					        {
  						  dyn_string dsT1 = strsplit(dsParameters[UN_PARAMETER_DOMAIN], ",");
  						  sDomaine = dsT1[3];
                                                         // DebugN("case multiple DOMAIN Type= "+sDevType+" dsParameters="+dsParameters[UN_PARAMETER_DOMAIN]+" sDomain="+sDomaine); 	
  					        }
  					    // else
                                                  //    {
                                                  //      sDomaine = dsParameters[UN_PARAMETER_DOMAIN];
                                                  //      // DebugN("case single DOMAIN Type= "+sDevType+" dsParameters="+dsParameters[UN_PARAMETER_DOMAIN]+" sDomain="+sDomaine); 
                                                  //      
                                                  //    }
                                             */
                   				 
                                                    break;
									
									
					// single domain
					
					case "WFIPEvenAgent":
					case "WFIPOddAgent":		
					case "WFIPSegment":					
							sDomaine = dsParameters[UN_PARAMETER_DOMAIN];
					break;			
					default: 
						DebugN("*** ERROR Domain -->  dpe= " + sDpe+ "type UNKNOWN: <"+sDevType+">");
				}
				
			//DebugN("deviceName= "+deviceName+" sDomaine="+sDomaine);
			// other...
			
			dynClear(dsSplit);
			dsSplit=strsplit(sDpe,".");
			iLen=dynlen(dsSplit);
			if (iLen==4)	//CIET Device
				{
				if (dsSplit[2]=="ProcessInput")			// && sLocation!="" && sApplication!="" && sNature!="" && sDomaine!="")
					{
					sAlias=dpGetAlias(dsSplit[1] + ".");
					if (!bUseDpe)
						{
						sA=sAlias;
						sE = substr(sDpe,strpos(sDpe,".")+1, strlen(sDpe));
						}
					else
						{
						sA="";
						sE = sDpe;						
						}

					sN=sAlias + "." + dsSplit[4];
					// THCOUPLETEMPERATURECALC too long -> THCPTEMPCALC			
					if(patternMatch("thCoupleTemperatureCalc",dsSplit[4]))
						strreplace(sN, "thCoupleTemperatureCalc", "thCpTempCalc");
						
					// thermistorTemperatureCalcWithMSBOnly too long -> thCTempCalcMSB			
					if(patternMatch("thermistorTemperatureCalcWithMSBOnly",dsSplit[4]))
						strreplace(sN, "thermistorTemperatureCalcWithMSBOnly", "thCTempCalcMSB");
						
					// heatZeroHuitVoltRefVolMeasInVolts too long -> heat08VRefVolMeasInV			
					if(patternMatch("heatZeroHuitVoltRefVolMeasInVolts",dsSplit[4]))
						strreplace(sN, "heatZeroHuitVoltRefVolMeasInVolts", "heat08VRefVolMeasInV");
						
					// heatZeroVoltRefVolMeasInVolts too long -> heat0VRefVolMeasInV			
					if(patternMatch("heatZeroVoltRefVolMeasInVolts",dsSplit[4]))
						strreplace(sN, "heatZeroVoltRefVolMeasInVolts", "heat0VRefVolMeasInV");
						
					// protectionRefVolMeasInVolts too long -> protRevVolMeasInV			
					if(patternMatch("protectionRefVolMeasInVolts",dsSplit[4]))
						strreplace(sN, "protectionRefVolMeasInVolts", "protRevVolMeasInV");
						
					// heatZeroHuitVoltRefVolMeas too long -> heat08VRefVolMeas			
					if(patternMatch("heatZeroHuitVoltRefVolMeas",dsSplit[4]))
						strreplace(sN, "heatZeroHuitVoltRefVolMeas", "heat08VRefVolMeas");
						
					// thermistorTemperatureCalc too long -> thStorTempCalc			
					if(patternMatch("thermistorTemperatureCalc",dsSplit[4]))
						strreplace(sN, "thermistorTemperatureCalc", "thStorTempCalc");
						
					// heatRelativeRefVolInVolts too long -> heatRelRefVolInV			
					if(patternMatch("heatRelativeRefVolInVolts",dsSplit[4]))
						strreplace(sN, "heatRelativeRefVolInVolts", "heatRelRefVolInV");
						
					// protectionVolMeasInVolts too long -> protVolMeasInV			
					if(patternMatch("protectionVolMeasInVolts",dsSplit[4]))
						strreplace(sN, "protectionVolMeasInVolts", "protVolMeasInV");
						
					// thermocoupleVoltageCalc too long -> thCpVoltCalc			
					if(patternMatch("thermocoupleVoltageCalc",dsSplit[4]))
						strreplace(sN, "thermocoupleVoltageCalc", "thCpVoltCalc");
						
					// diagnosticSelectionBits too long -> diagSelecBits			
					if(patternMatch("diagnosticSelectionBits",dsSplit[4]))
						strreplace(sN, "diagnosticSelectionBits", "diagSelecBits");
						
					// heatZeroVoltRefVolMeas too long -> heat0VRefVolMeas			
					if (patternMatch("heatZeroVoltRefVolMeas",dsSplit[4]))
						strreplace(sN, "heatZeroVoltRefVolMeas", "heat0VRefVolMeas");
						
					sD=unGenericDpFunctions_getDescription(deviceName);

					bOK=TRUE;
					if (sLocation=="")
						{
						bOK=FALSE;
						DebugN("ERROR: Location is empty for " + deviceName);
						}
					else
						{
						if (sApplication=="")
							{
							bOK=FALSE;
							DebugN("ERROR: Application is empty for " + deviceName);							
							}
						else
							{
							if (sNature=="")
								{
								bOK=FALSE;
								DebugN("ERROR: Nature is empty for " + deviceName);															
								}
							else
								{
								if (sDomaine=="")
									{
									bOK=FALSE;
									DebugN("ERROR: Domain is empty for " + deviceName);																
									}
								}
							}
						}
						
					if (bOK)
						sH=c_Activity + "/" + sLocation + "/" + sApplication + "/" + sNature + "/" + sDomaine;		//Unicos hierarchy
					
					}
				else
					{
					DebugN("Error: \"ProcessInput\" pattern not found!");
					}					
				}
			
			else if (iLen==2)	
				{
					//System Alarm ?
			 		dynClear(dsSplit);
			 		dsSplit=strsplit(sDpe,".");
			 		if (dsSplit[2]=="ST_GTWDEV")
			  		// Treat: sDpe= un-CFC_SH8_QL1IJ__Z-RM_UJ76-EH-00001.ST_GTWDEV
			  		{ 
			  		//DebugN("************* ST_GTWDEV *****************");
			  		sAlias=dpGetAlias(dsSplit[1] + ".");
			  		sA=sAlias;
			  		sE = substr(sDpe,strpos(sDpe,".")+1, strlen(sDpe));
			  		sN=sAlias + "." + dsSplit[2];
						sD=unGenericDpFunctions_getDescription(deviceName);
			  		sH=c_Activity + "/" + sLocation + "/" + sApplication + "/" + sNature + "/" + sDomaine;		//Unicos hierarchy
			  		}
			 		else		
						unUserlib_SystemAlarmInfo(dsSplit, sLocation, sE, sD, sA, sN, sH);
				}
			break;
		
		case 1:
			sN=sDpe;
			unCoreLHCServices_set_SystemName(sN, bState, false);
			sH=substr(sSystemName,0,strpos(sSystemName,":")) + "/" + dpTypeName(sDpe);
			sD=dpGetDescription(sDpe,0);
			sA="";
			sE=sDpe;

			break;
		
		default:
			sN="";
			sH="";
			sD="";
			sA="";
			sE="";

		}
//	DebugN("sN,sD,sH,sA,sE",sN,sD,sH,sA,sE);	
}
