/**@name LIBRARY: cietConstant_declarations.ctl

@author: Celine VUILLERMOZ (AB/CO)

Creation Date: 20 07 2005

Modification History: 
        24/07/13  achiron:      change the constants for the database connection
        30/11/11  Herve:        CIET-67, include cietConstant_installation.ctc
        06/10/11  achiron       Add constants for COMBO_BOX hasAPlc
        05/10/11  achiron       Add faceplate constant for button HasAPlc
        05/10/11  achiron:      Add constants for COMBO_BOX isForcedGain and gainFlag
        05/10/11  achiron       Add faceplate constant for button GAIN 
        16/03/09  Quique:       Delete hardcoded passwords by default
        16/03/09  Quique:       Update to a public login/password to get calibration tables
        16/02/09  Quique:       New constants for LT device: LevelOffset, GainCorrection commands
        12/02/09  Quique        New constants for calibration ID for LT: ciet_CONFIG_LT_CALIBRATION
        07/01/09  Quique:       New constants for unification of max scales + typical values for visualization (Sensor, Shunt, Th)        
        05/01/09 Quique:        Correct the FULLSCALE_MAXDATA_refVolMeas to be 65535 (2^16 -1)
                                Correct ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_4 = 59;
 	13/05/08 Pablo: 	Constants for Domain, Groups and Users.
 	10/12/07 Pablo: 	Constants for Oracle Database.
 	05/11/07 Pablo: 	Constants for open wfipagent, wfipsegment, plc and crate from popup menu.
 	23/08/07 Pablo: 	Constants for popup menu order.
 										Constants for Help popup menu.
 	21/06/07 Pablo: 	Added buttons for TendParam, Disable and Debug.
 										Added Tendency command.
 	20/06/07 Pablo: 	Disable widget animation.
 	19/06/07 Pablo: 	Included Command for Disable.
 	22/05/07 Pablo: 	Erased constant for FIPInfos (Button and right-click menu). Already included in UNICOS.
 	02/05/07 Pablo: 	Added constants for config new device CryoSgtPLC.
 	18/04/07 Pablo: 	Added constant for FIPInfos (Button and right-click menu).
 	16/04/07 Pablo: 	Added constant for Heater Over Temperature on EH widget animation.
 	05/04/07 Pablo: 	Added constants to open Expert Console.
 	26/03/07 Pablo: 	Added crate Level parameter for reset Agent.
	21/03/07 Pablo:	 	Added constants to agent common config for reset behaviour.
	07/03/07 Pablo:	 	Added filtering letters for widgets.
	19/02/07 Pablo:	 	Added Index for import: Engineering values for EH,LT,TT and PT.
										Include Command for Offset.
	16/02/07 Pablo:	 	Added more constants for Trend and PvRange.
	14/02/07 Pablo:	 	Added more constants for Filtering.
	09/02/07 Pablo:	 	Added constants for Filtering.
	05/02/07 Pablo:	 	Added constants for full scale on EH, LT, TT and PT.
	30/11/06 Pablo:	 	Changed presssure and resistance minimum limits on PT.
	21/11/06 Pablo:	  Added constants for import of cietProfileGraph
	21/11/06 Quique:	ST_GTWDEV constants modification.
  18/11/06 Quique:	Introduce new constants to manage the version number & debugging commands to FEC
	17/11/06 Quique:	"ohms" becomes "o" for space purposes / "V" becomens nothing.
	10/11/06 Quique:	"ohms" to "ohm" in both PT, TT
	10/11/06 Pablo:		"ohms" to "Ohm" in ciet_CONFIG_[device]_UNIT_OHMS
	08/11/06 Quique: 	UN_CONFIG_CRYOGTW_DI_LENGTH changed to 3
	02/11/06 Pablo:		Redefined UN_CONFIG_CRYOGTW_(DEVICE)_ARCHIVE_ACTIVE and UN_CONFIG_CRYOGTW_(DEVICE)_LENGTH values 
										to arrange archive calculation during installation process.
	09/10/06 Quique:	Include constants for EH types
	25/09/06 Pablo:		Include new letter (left up corner) to show Fault devices (i.e.: non existing in Gateway)
	25/09/06 Quique:	Include units for the thcouple
	18/09/06 Quique:	Include constants for updating rawdata (button)
	18/09/06 Pablo:	 	Include constant for widget
	18/09/06 Quique: 	Include constants for updating rawdata (button)
	03/09/06 Pablo:  	Include constants for EH Level powerCalc WIDGET_ANIMATION.
	08/09/06 Quique: 	Include constans to assing slot number of the gateway to the WFIP crates Levels (TOP, BOTTON).
	01/09/06 Pablo:  	Include constants for SetPointButton and NormalModeButton. (EH device)
	22/08/06 Quique: 	Include constants for the Cycle period cases. (EH device)
										Include new commands (cycleperiod, hysteresis) for EH devices.
	21/08/06 Quique: 	Include UNIT in the imporation file for TT,PT,LT,EH devices. (new constant and renumbering)
	18/08/06 Quique: 	New parameter in CRYOGTW definition: CRYO_CONFIG_CRYOGTW_FIPSEGMENT
										This models the concept of virtual GTwy, one per Wfip segment 
	15/08/06 Quique:	New constants for CMW sufix (:out, \timestamp)
	11/08/06 Quique: 	New constants for deadbands types and buttons
	09/08/06 Quique: 	New units for gain values and modify resistance constant
	08/08/05 Herve:		Add constants for PT, TT, LT
	25/07/05 Herve:		Add all the constant for the CRYOGTW: import, systemIntegrity
	
*/

#uses "cietConstant_installation.ctc"

// constant declaration

// Constans for Domain, Groups and Users.


const string CIET_ACCESS_CONTROL_DOMAIN_NAME = "CIET";
const string CIET_UNICOS_ACCESS_CONTROL_DOMAIN_NAME = "UNICOS";

const string CIET_MONITOR_GROUPNAME = "cietmonitor";
const string CIET_OPERATOR_GROUPNAME = "cietoperator";
const string CIET_EXPERT_GROUPNAME = "cietexpert";
const string CIET_ADMIN_GROUPNAME = "cietadmin";

const string CIET_MONITOR_USERNAME = "cietmonitor";
const string CIET_OPERATOR_USERNAME = "cietoperator";
const string CIET_EXPERT_USERNAME = "cietexpert";
const string CIET_ADMIN_USERNAME = "cietadmin";

// Constants for Disable Device
const int ciet_DISABLE=1;
const int ciet_ENABLE=0;

// Constants for Calibration ID availability
const string ciet_CALIBRATION_NOT_AVAILABLE="NOT_AVAILABLE";
const string ciet_CALIBRATION_NOT_APPLICABLE="NOT_APPLICABLE";

// Constants for WFIP ORDER CONNECTION IN THE CRATE
const int ciet_WFIP_CRATE_NUMBER_TOP_LEVEL=1;
const int ciet_WFIP_CRATE_NUMBER_BOTTON_LEVEL=3;

// Reset calculations
const int ciet_PARAM_RESET_DEVICE=1;
const int ciet_PARAM_RESET_GATEWAY=2;
const int ciet_PARAM_RESET_TOPEVEN_AGENT=3;
const int ciet_PARAM_RESET_TOPODD_AGENT=4;
const int ciet_PARAM_RESET_BOTTONEVEN_AGENT=5;
const int ciet_PARAM_RESET_BOTTONODD_AGENT=6;
const int ciet_PARAM_RESET_CRATE=7;
const int ciet_PARAM_RESET_TOPSEGMENT=8;
const int ciet_PARAM_RESET_BOTTONSEGMENT=9;

// constants for CMW addressing 
const string ciet_CMW_ADDRESS_INPUT_SUFIX="/timeStamp";		// Time Stamp is a tag of the property
const string ciet_CMW_ADDRESS_OUTPUT_SUFIX=":out";			// To avoid duplicate CMW addresses when property is R/W in FESA
const string ciet_CMW_ADDRESS_OUTPUT_TAG_SUFIX_DIM=":2";		// Write CMW float array [2x65] when having a dyn_float (130 floats) as dpe
const string ciet_CMW_ADDRESS_OUTPUT_PROPERTY_SUFIX_DIM=":xD.array";	// Write sufix to propery when the property is dyn_float

const string ciet_CMW_ADDRESS_ST_GTWDEV_TAG="contents";									// ST_GTWDEV cmw address
const string ciet_CMW_ADDRESS_ST_GTWDEV_PROPERTY_SUFIX=":pseudo.dev";		//  ST_GTWDEV cmw address

// constant for import of CRYOGTW
const string CRYO_CRYOGTW_DPTYPE = "CRYOGTW";
const unsigned CRYO_CONFIG_CRYOGTW_LENGTH = 6;
const unsigned CRYO_CONFIG_CRYOGTW_DEVICE = 4;
const unsigned CRYO_CONFIG_CRYOGTW_FIPSEGMENT=5;	// address of th liveCounter of the FIP network (VIRTUAL GTWY)
const unsigned CRYO_CONFIG_CRYOGTW_CIET_VERSION=6; // User specification version

const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_LENGTH = 6;	// 5 parameters
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_FRONTEND = 1;	// front-end type
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_NAME = 2;	// name
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_ADDRESS = 3;	// Address in front-end
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_OKALARM = 4;	// true=alarm if value>10, false (default) = alarm if value<=10
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_DESCRIPTION = 5;	// description
const unsigned CRYO_CRYOGTW_CHECKFESYSTEM_ALARM_CMWDEVICE = 6;	// description

const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_LENGTH = 13;	// 13 parameters

const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_NAME = 1;	// name
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_ADDRESS = 2;	// Address in front-end
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_OKALARM = 3;	// true=alarm if value>10, false (default) = alarm if value<=10
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_DESCRIPTION = 4;	// description
const unsigned CRYO_CRYOGTW_SETFESYSTEM_ALARM_CMWDEVICE = 5;	// device

const unsigned CRYO_CRYOGTW_FESYSTEMALARM_DEVICENAME = 6;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_PLCNAME = 7;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_TYPE = 8;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_PLCNUMBER = 9;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_DRIVER = 10;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_EVENT16 = 11;
const unsigned CRYO_CRYOGTW_FESYSTEMALARM_ARCHIVE = 12;

// constant for CRYOGTW system integrity

const string c_CRYO_FRONTEND_UNSYSTEMALARM = "_unSystemAlarm";
const string c_cietSystemIntegrity_DS	= "_DS_Comm_";
const string c_cietSystemIntegrity_CRYOGTW = "CRYOGTW_";
const string UN_SYSTEM_INTEGRITY_CRYOGTW = "CRYOGTW";
const string UN_SYSTEM_INTEGRITY_CRYOGTW_check = "cietSystemIntegrity_CRYOGTWCheck";
const string c_cietSystemIntegrity_CRYOGTW_Time_callback = "cietSystemIntegrity_CRYOGTWTimeCallback";
const int c_cietSystemIntegrity_defaultCRYOGTWCheckingDelay = 10; // default value for the checking in sec.
const int CRYO_SYSTEM_INGETRITY_ALARM_LIMIT = 10;

// global declaration for systemIntegrity
global dyn_string g_cietSystemIntegrity_CRYOGTW_DSList; // list of the CRYOGTW-DS dp checked
global dyn_int g_cietSystemIntegrity_CRYOGTW_DSThreadId; // list of the CRYOGTW-DS thread Id checking the counter
global int g_cietSystemIntegrity_CRYOGTWCheckingDelay;

// constants for faceplate
const string ciet_FACEPLATE_BUTTON_DISABLE="Disable";
const string ciet_FACEPLATE_BUTTON_ENABLE="Enable";
const string ciet_FACEPLATE_BUTTON_DISABLEWD="DisableWatchDog";
const string ciet_FACEPLATE_BUTTON_ENABLEWD="EnableWatchDog";
const string ciet_FACEPLATE_BUTTON_RESET="Reset";
const string ciet_FACEPLATE_BUTTON_CALIBRATION="Calibration";
const string ciet_FACEPLATE_BUTTON_CONSTANTS="Constants";
const string ciet_FACEPLATE_BUTTON_PREFIX="button";
const string ciet_FACEPLATE_BUTTON_FORCED_MODE="ForcedMode";
const string ciet_FACEPLATE_BUTTON_AUTO_MODE="AutoMode";
const string ciet_FACEPLATE_BUTTON_SETPOINT="SetPoint";
const string ciet_FACEPLATE_BUTTON_DEADBANDS="DeadBands";
const string ciet_FACEPLATE_BUTTON_CONFIG="Config";
const string ciet_FACEPLATE_BUTTON_RAWDATA="RawData";
const string ciet_FACEPLATE_BUTTON_ENABLECOMMWD="EnableWD";
const string ciet_FACEPLATE_BUTTON_SETPRODUCTIONRAWDATA="SetRawData";
const string ciet_FACEPLATE_BUTTON_DIAG="Diag";
const string ciet_FACEPLATE_BUTTON_FILTERING="Filtering";
const string ciet_FACEPLATE_BUTTON_FIPINFOS="FIPInfos";
const string ciet_FACEPLATE_BUTTON_TENDPARAM="TendParam";
const string ciet_FACEPLATE_BUTTON_DEBUG="Debug";
const string ciet_FACEPLATE_BUTTON_FORCEDGAIN="ForcedGain";
const string ciet_FACEPLATE_BUTTON_PLCCONFIG="PLCConfig";
const string ciet_FACEPLATE_BUTTON_ACTIVATION="Activation";
const string ciet_FACEPLATE_BUTTON_DIAGNOSTIC="Diagnostic";

// constants for popup menu
const string ciet_POPUPMENU_DISABLE="Disable";
const string ciet_POPUPMENU_ENABLE="Enable";
const string ciet_POPUPMENU_RESET="Reset";
const string ciet_POPUPMENU_CALIBRATION="Calibration";
const string ciet_POPUPMENU_CONSTANTS="Constants";
const string ciet_POPUPMENU_DEADBANDS="DeadBands";
const string ciet_POPUPMENU_CONFIG="Config";
const string ciet_POPUPMENU_FORCED_MODE="ForcedMode";
const string ciet_POPUPMENU_AUTO_MODE="AutoMode";
const string ciet_POPUPMENU_SETPOINT="SetPoint";
const string ciet_POPUPMENU_RAWDATA="RawData";
const string ciet_POPUPMENU_FILTERING="Filtering";
const string ciet_POPUPMENU_FIPINFOS="FIPInfos";
const string ciet_POPUPMENU_TENDPARAM="TendParam";
const string ciet_POPUPMENU_DEBUG="Debug";
const string ciet_POPUPMENU_HELP="Help";
const string ciet_POPUPMENU_WIDGET_SIMULATOR="WidgetSimulator";
const string ciet_POPUPMENU_OPEN_WFIPAGENT="Agent";
const string ciet_POPUPMENU_OPEN_WFIPSEGMENT="Bus";
const string ciet_POPUPMENU_OPEN_PLC="PLC";
const string ciet_POPUPMENU_OPEN_CRATE="Crate";

// constants for popup menu order

const int ciet_POPUPMENU_ORDER_RESET=1;
const int ciet_POPUPMENU_ORDER_CONFIG=2;
const int ciet_POPUPMENU_ORDER_DISABLE=3;
const int ciet_POPUPMENU_ORDER_DEBUG=4;
const int ciet_POPUPMENU_ORDER_DEADBANDS=5;
const int ciet_POPUPMENU_ORDER_CONSTANTS=6;
const int ciet_POPUPMENU_ORDER_CALIBRATION=7;
const int ciet_POPUPMENU_ORDER_FORCED_MODE=8;
const int ciet_POPUPMENU_ORDER_AUTO_MODE=9;
const int ciet_POPUPMENU_ORDER_SETPOINT=10;
const int ciet_POPUPMENU_ORDER_TENDPARAM=11;
const int ciet_POPUPMENU_ORDER_FILTERING=12;
const int ciet_POPUPMENU_ORDER_HELP=13;
const int ciet_POPUPMENU_ORDER_FIPINFOS=14;
const int ciet_POPUPMENU_ORDER_WIDGET_SIMULATOR=15;
const int ciet_POPUPMENU_ORDER_OPEN_WFIPAGENT=16;
const int ciet_POPUPMENU_ORDER_OPEN_WFIPSEGMENT=17;
const int ciet_POPUPMENU_ORDER_OPEN_PLC=18;
const int ciet_POPUPMENU_ORDER_OPEN_CRATE=19;

// constant for import of cietProfileGraph
const int CIET_PROFILE_GRAPH_TT = 1;
const int CIET_PROFILE_GRAPH_PT = 2;
const int CIET_PROFILE_GRAPH_LT = 3;
const int CIET_PROFILE_GRAPH_EH = 4;
const int CIET_PROFILE_GRAPH_DI = 5;

// constants for Oracle Database
const string ciet_ORACLE_ORADRIVER ="QOCI8";		
const string ciet_ORACLE_DRIVER ="Driver=QOCI8";
const string ciet_ORACLE_DATABASE="Database=edmsdb;";
const string ciet_ORACLE_USER ="User=cryocontrols_pub;";
const string ciet_ORACLE_PASSWORD ="Password=penguin09";      // PUBLIC password (only read access)
const int CIET_TABLE_HEIGHT=65;
	
//---------------------------------------------------------------------------------------------------------------------------------------


//---------
// WIDGETS
//---------

const string ciet_WIDGET_TEXT_WARNING_DISABLE = "D";							// Disable
const string ciet_WIDGET_TEXT_STATUS_GATEWAY_DEVICE = "F";				// Fault device (case not declared in gateway)
const string ciet_WIDGET_TEXT_FILTERING_MEDIAN = "M";							// Filtering Median
const string ciet_WIDGET_TEXT_FILTERING_AVERAGE = "A";						// Filtering Average
const string  ciet_WIDGET_TEXT_FORCED_MODE = "F";									// Forced Mode


// Constants for commands
const int ciet_COMMAND_DISABLE =1;												// Enable/Disable devices
const int ciet_COMMAND_UPDATE_CURVE =1;										// Update calibration curve (TT,PT,EH)
const int ciet_COMMAND_SET_RMAX=2;												// Set Rmax value (LT)
const int ciet_COMMAND_SET_LMAX=3;												// Set Lmax value (LT)
const int ciet_COMMAND_SET_INCLINATION=4;									// Set Inclination value (LT)
const int ciet_COMMAND_UPDATE_THOLD=5;										// Update threshold value (EH)
const int ciet_COMMAND_SET_FORCEDMODE=6;									// Set forced mode (EH and LT)
const int ciet_COMMAND_SET_NORMALMODE=7;									// Set auto mode (EH and LT)
const int ciet_COMMAND_SET_TENDENCY=10;										// Tendency
const int ciet_COMMAND_SET_FILTERING_SAMPLES=50;					// Set Filtering Samples
const int ciet_COMMAND_FILTERING_MODE=51;									// Filtering Mode
const int ciet_COMMAND_SET_OFFSET=52;											// Offset
const int ciet_COMMAND_SET_LEVELOFFSET=60;                                        // Change level offset (LT device)
const int ciet_COMMAND_SET_GAINCORRECTION=61;                                     // Change gain correction (LT device)   
const int ciet_COMMAND_SET_ISFORCEDGAIN=60; //change the mode for the gain for TT
const int ciet_COMMAND_SET_FORCEDGAINFLAG=61; //change the value of the gain flag for TT
const int ciet_COMMAND_SET_HASAPLCCONNECTED=2; //change the value of the hasAPlcConnected flag
const int ciet_COMMAND_SET_ISFORCEDPRODUCTIONRAWDATA=2; //change the value of the isForcedProductionRawData flag
const int ciet_COMMAND_SET_ENABLECOMMWD=14; //Enable/Disable comm watchdog

const int ciet_COMMAND_RESET_SL_ALL_TT_PT_LT_DI =8;				// RESET sameLevel_all-TT-PT-LT-DI
const int ciet_COMMAND_RESET_SL_ALL_EH =9;								// RESET sameLevel_all-EH
const int ciet_COMMAND_RESET_OL_BOTH_FIP =10;							// RESET oppositeLevel_both_FIP
const int ciet_COMMAND_RESET_OL_ALL_TT_PT_LT_DI =11;			// RESET oppositeLevel_all-TT-PT-LT-DI
const int ciet_COMMAND_RESET_OL_ALL_EH =12;								// RESET oppositeLevel_all-EH
const int ciet_COMMAND_RESET_OL_PS =13;										// RESET oppositeLevel_PowerSupply

const int ciet_COMMAND_UPDATE_HEATERESISTANCE=14;					// Update heater resistance value (EH)
const int ciet_COMMAND_UPDATE_THCOUPLEOFFSET=15;					// Update thermocouple offset value (EH)
const int ciet_COMMAND_UPDATE_HYSTERESIS=16;							// Update Hysteresis value (EH)
const int ciet_COMMAND_UPDATE_CYCLEPERIOD=17;							// Update Cycle period value (EH)

const int ciet_COMMAND_UPDATE_WatchDogStatus = 20;                      // Update watch dog status (EHBS)
const int ciet_COMMAND_UPDATE_PowerCycleStatus = 23;                    // Update power cycle status (EHBS)
const int ciet_COMMAND_UPDATE_OnOffStatus = 21;                         // Update OnOff status (EHBS)
const int ciet_COMMAND_UPDATE_EnableDisableStatus = 22;                 // Update Enable/Disable status (EHBS)
const int ciet_COMMAND_UPDATE_DiagnosticMode = 24;                 // Update Enable/Disable status (EHBS)
const int ciet_COMMAND_UPDATE_HeatACOffset = 18;                        // Update heat AC offset (EHBS)
const int ciet_COMMAND_UPDATE_ptSensorRange = 19;                       // Update PT Sensor Range (EHBS)


// Constants for dynamic DEBUGGING 
const int ciet_COMMAND_ENABLE_DEBUG= 30;									// FEC activates debugging lines						
const int ciet_COMMAND_DISABLE_DEBUG=31;									// FEC disables debugging lines


//---------------------------------------------------------------------------------------------------------------------------------------

// Constants for DEADBAND TYPES
const int ciet_DEADBAND_TYPE_DISABLED=0;
const int ciet_DEADBAND_TYPE_ABSOLUTE=1;
const int ciet_DEADBAND_TYPE_RELATIVE=2;

// Constants for isForcedGain TYPES
const int ciet_ISFORCEDGAIN_TYPE_DISABLED=0;
const int ciet_ISFORCEDGAIN_TYPE_ENABLED=1;

// Constants for GainFlag TYPES
const int ciet_GAINFLAG_TYPE_1=1;
const int ciet_GAINFLAG_TYPE_2=2;
const int ciet_GAINFLAG_TYPE_4=4;

// Constants for hasAPlcConnected TYPES
const int ciet_HASAPLCCONNECTED_TYPE_TRUE=1;
const int ciet_HASAPLCCONNECTED_TYPE_FALSE=0;

// Constants for isForcedProductionRawData TYPES
const int ciet_ISFORCEDPRODUCTIONRAWDATA_TYPE_TRUE=1;
const int ciet_ISFORCEDPRODUCTIONRAWDATA_TYPE_FALSE=0;
// constants for Agent

const unsigned ciet_CONFIG_COMMON_AGENT_LENGTH = 8;
const unsigned ciet_CONFIG_COMMON_AGENT_CMWDEVICE = 1;
const unsigned ciet_CONFIG_COMMON_AGENT_CRATE_LEVEL = 2;
const unsigned ciet_CONFIG_COMMON_AGENT_PARTNER = 3;
const unsigned ciet_CONFIG_COMMON_AGENT_OPPOSITE_ODD = 4;
const unsigned ciet_CONFIG_COMMON_AGENT_OPPOSITE_EVEN = 5;
const unsigned ciet_CONFIG_COMMON_AGENT_OPPOSITE_NET = 6;
const unsigned ciet_CONFIG_COMMON_AGENT_ARCHIVEACTIVE = 7;
const unsigned ciet_CONFIG_COMMON_AGENT_ARCHIVETIMEFILTER = 8;


const unsigned UN_CONFIG_CRYOGTW_COMMON_AGENT_ARCHIVE_ACTIVE = 7;
const unsigned UN_CONFIG_CRYOGTW_COMMON_AGENT_LENGTH = 8;


//---------------------------------------------------------------------------------------------------------------------------------------

// constants for PT device

const unsigned ciet_CONFIG_PT_LENGTH = 7;
const unsigned ciet_CONFIG_PT_UNIT = 1;
const unsigned ciet_CONFIG_PT_RANGEMIN = 2;
const unsigned ciet_CONFIG_PT_RANGEMAX = 3;
const unsigned ciet_CONFIG_PT_CALIBRATION = 4;
const unsigned ciet_CONFIG_PT_CMWDEVICE = 5;
const unsigned ciet_CONFIG_PT_ARCHIVEACTIVE = 6;
const unsigned ciet_CONFIG_PT_ARCHIVETIMEFILTER = 7;

const unsigned UN_CONFIG_CRYOGTW_PT_ARCHIVE_ACTIVE = 6;
const unsigned UN_CONFIG_CRYOGTW_PT_LENGTH = 7;

const int ciet_CONFIG_PT_MAXVALUE_senVolMeas = 32767;
const int ciet_CONFIG_PT_MINVALUE_senVolMeas = -32767;
const int ciet_CONFIG_PT_MAXVALUE_refVolMeas = 32767;
const int ciet_CONFIG_PT_MINVALUE_refVolMeas = -32767;
const int ciet_CONFIG_PT_MAXVALUE_gainValue = 105;
const int ciet_CONFIG_PT_MINVALUE_gainValue = -105;
const int ciet_CONFIG_PT_MAXVALUE_resistanceCalc = 10;
const int ciet_CONFIG_PT_MINVALUE_resistanceCalc = 0;

const float ciet_CONFIG_PT_FULLSCALE_refVolMeas = 238;
const string ciet_CONFIG_PT_FULLSCALE_UNIT_refVolMeas = "mV";
const string ciet_CONFIG_PT_TYPICAL_VALUE_UNIT_refVolMeas = "mV";
const int ciet_CONFIG_PT_FULLSCALE_MAXDATA_refVolMeas = 65535;	// 16 bits  (FFFFh) ( 2^16 -1)
const float ciet_CONFIG_PT_TYPICAL_VALUE_refVolMeas = 8.8;

const float ciet_CONFIG_PT_FULLSCALE_senVolMeas = 238;
const string ciet_CONFIG_PT_FULLSCALE_UNIT_senVolMeas = "mV";
const int ciet_CONFIG_PT_FULLSCALE_MAXDATA_senVolMeas = 65535;	// 16 bits  (FFFFh) ( 2^16 -1)

const string ciet_CONFIG_PT_UNIT_VOLT = "";
const string ciet_CONFIG_PT_UNIT_DB = "";
const string ciet_CONFIG_PT_UNIT_OHMS = "ohm";
// const string ciet_CONFIG_PT_UNIT_BAR = "bars";



//---------------------------------------------------------------------------------------------------------------------------------------
// constants for TT device
const unsigned ciet_CONFIG_TT_LENGTH = 7;
const unsigned ciet_CONFIG_TT_UNIT = 1;
const unsigned ciet_CONFIG_TT_RANGEMIN = 2;
const unsigned ciet_CONFIG_TT_RANGEMAX = 3;
const unsigned ciet_CONFIG_TT_CALIBRATION = 4;
const unsigned ciet_CONFIG_TT_CMWDEVICE = 5;
const unsigned ciet_CONFIG_TT_ARCHIVEACTIVE = 6;
const unsigned ciet_CONFIG_TT_ARCHIVETIMEFILTER = 7;

const unsigned UN_CONFIG_CRYOGTW_TT_ARCHIVE_ACTIVE = 6;
const unsigned UN_CONFIG_CRYOGTW_TT_LENGTH = 7;

const int ciet_CONFIG_TT_MAXVALUE_senVolMeas = 32767;
const int ciet_CONFIG_TT_MINVALUE_senVolMeas = -32767;
const int ciet_CONFIG_TT_MAXVALUE_refVolMeas = 32767;
const int ciet_CONFIG_TT_MINVALUE_refVolMeas = -32767;
const int ciet_CONFIG_TT_MAXVALUE_gainValue = 105;
const int ciet_CONFIG_TT_MINVALUE_gainValue = -105;
const int ciet_CONFIG_TT_MAXVALUE_resistanceCalc = 40000;
const int ciet_CONFIG_TT_MINVALUE_resistanceCalc = 0;

const float ciet_CONFIG_TT_FULLSCALE_refVolMeas = 238;
const string ciet_CONFIG_TT_FULLSCALE_UNIT_refVolMeas = "mV";
const int ciet_CONFIG_TT_FULLSCALE_MAXDATA_refVolMeas = 65535;	// 16 bits  (FFFFh) ( 2^16 -1)
const float ciet_CONFIG_TT_TYPICAL_VALUE_refVolMeas = 10;
const string ciet_CONFIG_TT_TYPICAL_VALUE_UNIT_refVolMeas = "mV";

const float ciet_CONFIG_TT_FULLSCALE_senVolMeas = 238;
const string ciet_CONFIG_TT_FULLSCALE_UNIT_senVolMeas = "mV";
const int ciet_CONFIG_TT_FULLSCALE_MAXDATA_senVolMeas = 65535;	// 16 bits  (FFFFh) ( 2^16 -1)

const string ciet_CONFIG_TT_UNIT_VOLT = "";
const string ciet_CONFIG_TT_UNIT_DB = "";
const string ciet_CONFIG_TT_UNIT_OHMS = "ohm";
// const string ciet_CONFIG_TT_UNIT_TEMP = "K";

//---------------------------------------------------------------------------------------------------------------------------------------
// constants for LT device
const unsigned ciet_CONFIG_LT_LENGTH = 7;
const unsigned ciet_CONFIG_LT_UNIT = 1;
const unsigned ciet_CONFIG_LT_RANGEMIN = 2;
const unsigned ciet_CONFIG_LT_RANGEMAX = 3;
const unsigned ciet_CONFIG_LT_CALIBRATION = 4;
const unsigned ciet_CONFIG_LT_CMWDEVICE = 5;
const unsigned ciet_CONFIG_LT_ARCHIVEACTIVE = 6;
const unsigned ciet_CONFIG_LT_ARCHIVETIMEFILTER = 7;

const unsigned UN_CONFIG_CRYOGTW_LT_ARCHIVE_ACTIVE = 5;
const unsigned UN_CONFIG_CRYOGTW_LT_LENGTH = 6;


const int ciet_CONFIG_LT_MAXVALUE_senVolMeas = 32767;
const int ciet_CONFIG_LT_MINVALUE_senVolMeas = -32767;
const int ciet_CONFIG_LT_MAXVALUE_refVolMeas = 32767;
const int ciet_CONFIG_LT_MINVALUE_refVolMeas = -32767;
const int ciet_CONFIG_LT_MAXVALUE_gainValue = 105;
const int ciet_CONFIG_LT_MINVALUE_gainValue = -105;
const int ciet_CONFIG_LT_MAXVALUE_resistanceCalc = 100;
const int ciet_CONFIG_LT_MINVALUE_resistanceCalc = 0;

const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_1 = 40;
const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_2 = 46;
const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_3 = 52;
const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_4 = 59;
const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_5 = 69;
const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_6 = 78;
const float ciet_CONFIG_LT_TYPICAL_VALUE_refVolMeas_7 = 89;
const string ciet_CONFIG_LT_TYPICAL_VALUE_UNIT_refVolMeas = "mV";
const float ciet_CONFIG_LT_FULLSCALE_refVolMeas = 572;
const string ciet_CONFIG_LT_FULLSCALE_UNIT_refVolMeas = "mV";
const string ciet_CONFIG_LT_FULLSCALE_UNIT_senVolMeas = "V";
const float ciet_CONFIG_LT_FULLSCALE_senVolMeas_1 = 11.58;
const float ciet_CONFIG_LT_FULLSCALE_senVolMeas_2 = 20.08;
const float ciet_CONFIG_LT_FULLSCALE_senVolMeas_3 = 34.75;
const float ciet_CONFIG_LT_FULLSCALE_senVolMeas_4 = 56.47;
const int ciet_CONFIG_LT_FULLSCALE_MAXDATA_refVolMeas = 65535;	// 16 bits  (FFFFh) ( 2^16 -1)
const int ciet_CONFIG_LT_FULLSCALE_MAXDATA_senVolMeas = 65535;	// 16 bits  (FFFFh) ( 2^16 -1)

const string ciet_CONFIG_LT_UNIT_VOLT = "V";
const string ciet_CONFIG_LT_UNIT_DB = "";
const string ciet_CONFIG_LT_UNIT_OHMS = "ohm";
const string ciet_CONFIG_LT_UNIT_MM = "mm";
const string ciet_CONFIG_LT_UNIT_POURCENT = "%";
const string ciet_CONFIG_LT_UNIT_ANGLE = "deg";

const int ciet_LT_DISCONNECT_FORCED_DISABLE = 0;
const int ciet_LT_DISCONNECT_FORCED_ENABLE = 1;
					 
//---------------------------------------------------------------------------------------------------------------------------------------
// constants for EH device
	
//const unsigned ciet_CONFIG_EH_LENGTH = 18;
const unsigned ciet_CONFIG_EH_LENGTH = 7;
const unsigned ciet_CONFIG_EH_UNIT = 1;
const unsigned ciet_CONFIG_EH_RANGEMIN = 2;
const unsigned ciet_CONFIG_EH_RANGEMAX = 3;
const unsigned ciet_CONFIG_EH_CALIBRATION = 4;
const unsigned ciet_CONFIG_EH_CMWDEVICE = 5;
const unsigned ciet_CONFIG_EH_ARCHIVEACTIVE = 6;
const unsigned ciet_CONFIG_EH_ARCHIVETIMEFILTER = 7;

const unsigned UN_CONFIG_CRYOGTW_EH_ARCHIVE_ACTIVE = 6;
const unsigned UN_CONFIG_CRYOGTW_EH_LENGTH = 7;


// Constants for EH SETCONSTANTS
const int ciet_SETCONSTANTS_CYCLEPERIOD_1_25s=3;
const int ciet_SETCONSTANTS_CYCLEPERIOD_2_5s=2;		// 2.5 seconds
const int ciet_SETCONSTANTS_CYCLEPERIOD_5s=1;
const int ciet_SETCONSTANTS_CYCLEPERIOD_10s=0;

const int ciet_CONFIG_EH_MAXVALUE_heatVolMeas = 2047;
const int ciet_CONFIG_EH_MINVALUE_heatVolMeas = -2047;
const int ciet_CONFIG_EH_MAXVALUE_heatRefVolMeas = 2047;
const int ciet_CONFIG_EH_MINVALUE_heatRefVolMeas = -2047;
const int ciet_CONFIG_EH_MAXVALUE_shuntVolMeas = 2047;
const int ciet_CONFIG_EH_MINVALUE_shuntVolMeas = -2047;
const int ciet_CONFIG_EH_MAXVALUE_shuntRefVolMeas = 2047;
const int ciet_CONFIG_EH_MINVALUE_shuntRefVolMeas = -2047;
const int ciet_CONFIG_EH_MAXVALUE_thVolMeas = 63;
const int ciet_CONFIG_EH_MINVALUE_thVolMeas = -63;
const int ciet_CONFIG_EH_MAXVALUE_thRefVolMeas = 63;
const int ciet_CONFIG_EH_MINVALUE_thRefVolMeas = -63;
const int ciet_CONFIG_EH_MAXVALUE_HYSTERESIS = 7;
const int ciet_CONFIG_EH_MINVALUE_HYSTERESIS = 0;
const int ciet_CONFIG_EH_MAXVALUE_CYCLEPERIOD = 105;
const int ciet_CONFIG_EH_MINVALUE_CYCLEPERIOD = -105;
const int ciet_CONFIG_EH_MAXVALUE_suppliedVoltageCalc = 105;
const int ciet_CONFIG_EH_MINVALUE_suppliedVoltageCalc = -105;
const int ciet_CONFIG_EH_MAXVALUE_suppliedCurrentCalc = 105;
const int ciet_CONFIG_EH_MINVALUE_suppliedCurrentCalc = -105;
const int ciet_CONFIG_EH_MAXVALUE_thCoupleVoltageCalc = 105;
const int ciet_CONFIG_EH_MINVALUE_thCoupleVoltageCalc = -105;
const int ciet_CONFIG_EH_MAXVALUE_thCoupleTemperatureCalc = 105;
const int ciet_CONFIG_EH_MINVALUE_thCoupleTemperatureCalc = -10;
const int ciet_CONFIG_EH_MAXVALUE_thermocoupleOrPtTemperatureCalc = 105;
const int ciet_CONFIG_EH_MINVALUE_thermocoupleOrPtTemperatureCalc = -10;

const string ciet_CONFIG_EH_FORMAT_VOLT="V";
const string ciet_CONFIG_EH_FORMAT_MILIVOLT="mV";
const string ciet_CONFIG_EH_FORMAT_WATT="W";
const string ciet_CONFIG_EH_FORMAT_TIME="s";
const string ciet_CONFIG_EH_FORMAT_A="A";
const string ciet_CONFIG_EH_FORMAT_THCOUPLE="C";
const string ciet_CONFIG_EH_FORMAT_OHM="ohm";

const int ciet_EH_WIDGET_ANIMATION_MAXVALUE_powerCalc = 20;
const int ciet_EH_WIDGET_ANIMATION_MINVALUE_powerCalc = 5;

const float ciet_CONFIG_EH_TYPICAL_VALUE_heatRefVolMeas = 50;
const string ciet_CONFIG_EH_TYPICAL_VALUE_UNIT_heatRefVolMeas = "mV";
const float ciet_CONFIG_EH_FULLSCALE_heatRefVolMeas = 243.4;
const string ciet_CONFIG_EH_FULLSCALE_UNIT_heatRefVolMeas = "mV";
const int ciet_CONFIG_EH_FULLSCALE_MAXDATA_heatRefVolMeas = 4096;			// 12 bits  (4096)
const float ciet_CONFIG_EH_FULLSCALE_heatVolMeas = 243.4;
const string ciet_CONFIG_EH_FULLSCALE_UNIT_heatVolMeas = "mV";
const int ciet_CONFIG_EH_FULLSCALE_MAXDATA_heatVolMeas = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EH_25_500_TYPICAL_VALUE_shuntRefVolMeas = 50;
const string ciet_CONFIG_EH_25_500_TYPICAL_VALUE_UNIT_shuntRefVolMeas = "mV";
const float ciet_CONFIG_EH_25_500_FULLSCALE_shuntRefVolMeas = 243.4;
const string ciet_CONFIG_EH_25_500_FULLSCALE_UNIT_shuntRefVolMeas = "mV";
const int ciet_CONFIG_EH_25_500_FULLSCALE_MAXDATA_shuntRefVolMeas = 4096;		// 12 bits  (4096)
const float ciet_CONFIG_EH_25_500_FULLSCALE_shuntVolMeas = 243.4;
const string ciet_CONFIG_EH_25_500_FULLSCALE_UNIT_shuntVolMeas = "mV";
const int ciet_CONFIG_EH_25_500_FULLSCALE_MAXDATA_shuntVolMeas = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EH_100_TYPICAL_VALUE_shuntRefVolMeas = 50;      
const string ciet_CONFIG_EH_100_TYPICAL_VALUE_UNIT_shuntRefVolMeas = "mV";
const float ciet_CONFIG_EH_100_FULLSCALE_shuntRefVolMeas = 243.4;
const string ciet_CONFIG_EH_100_FULLSCALE_UNIT_shuntRefVolMeas = "mV";
const int ciet_CONFIG_EH_100_FULLSCALE_MAXDATA_shuntRefVolMeas = 4096;			// 12 bits  (4096)
const float ciet_CONFIG_EH_100_FULLSCALE_shuntVolMeas = 243.4;
const string ciet_CONFIG_EH_100_FULLSCALE_UNIT_shuntVolMeas = "mV";
const int ciet_CONFIG_EH_100_FULLSCALE_MAXDATA_shuntVolMeas = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EH_COMMON_TYPICAL_VALUE_shuntRefVolMeas = 50;      
const string ciet_CONFIG_EH_COMMON_TYPICAL_VALUE_UNIT_shuntRefVolMeas = "mV";
const float ciet_CONFIG_EH_COMMON_FULLSCALE_shuntRefVolMeas = 243.4;
const string ciet_CONFIG_EH_COMMON_FULLSCALE_UNIT_shuntRefVolMeas = "mV";
const int ciet_CONFIG_EH_COMMON_FULLSCALE_MAXDATA_shuntRefVolMeas = 4096;			// 12 bits  (4096)
const float ciet_CONFIG_EH_COMMON_FULLSCALE_shuntVolMeas = 243.4;
const string ciet_CONFIG_EH_COMMON_FULLSCALE_UNIT_shuntVolMeas = "mV";
const int ciet_CONFIG_EH_COMMON_FULLSCALE_MAXDATA_shuntVolMeas = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EH_TYPICAL_VALUE_thRefVolMeas = 27.7;
const string ciet_CONFIG_EH_TYPICAL_VALUE_UNIT_thRefVolMeas = "mV";
const float ciet_CONFIG_EH_FULLSCALE_thRefVolMeas = 93.2;
const string ciet_CONFIG_EH_FULLSCALE_UNIT_thRefVolMeas = "mV";
const int ciet_CONFIG_EH_FULLSCALE_MAXDATA_thRefVolMeas = 128;			// 7 bits  (128)
const float ciet_CONFIG_EH_FULLSCALE_thVolMeas = 93.2;
const string ciet_CONFIG_EH_FULLSCALE_UNIT_thVolMeas = "mV";
const int ciet_CONFIG_EH_FULLSCALE_MAXDATA_thVolMeas = 128;			// 7 bits  (128)

const string ciet_EH_WIDGET_ANIMATION_HEATER_OVER_TEMPERATURE_LETTER = "H";
const string ciet_EH_WIDGET_ANIMATION_CARD_OVER_TEMPERATURE_LETTER = "C";
const string ciet_EH_WIDGET_ANIMATION_HEATER_AND_CARD_OVER_TEMPERATURE_LETTER = "HC";

const string ciet_EH_TYPE_25W = "25w";
const string ciet_EH_TYPE_100W = "100w";
const string ciet_EH_TYPE_500W_25W = "500w+25w";
const string ciet_EH_TYPE_500W = "500w";

/*const unsigned UN_CONFIG_CRYOGTW_EH_ARCHIVE_ACTIVE = 17;
const unsigned UN_CONFIG_CRYOGTW_EH_LENGTH = 18;*/


//---------------------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------------------------
// constants for EHBS device
	
//const unsigned ciet_CONFIG_EHBS_LENGTH = 18;
const unsigned ciet_CONFIG_EHBS_LENGTH = 7;
const unsigned ciet_CONFIG_EHBS_UNIT = 1;
const unsigned ciet_CONFIG_EHBS_RANGEMIN = 2;
const unsigned ciet_CONFIG_EHBS_RANGEMAX = 3;
const unsigned ciet_CONFIG_EHBS_CALIBRATION = 4;
const unsigned ciet_CONFIG_EHBS_CMWDEVICE = 5;
const unsigned ciet_CONFIG_EHBS_ARCHIVEACTIVE = 6;
const unsigned ciet_CONFIG_EHBS_ARCHIVETIMEFILTER = 7;

const unsigned UN_CONFIG_CRYOGTW_EHBS_ARCHIVE_ACTIVE = 6;
const unsigned UN_CONFIG_CRYOGTW_EHBS_LENGTH = 7;


// Constants for EHBS SETCONSTANTS
const int ciet_CONFIG_EHBS_MAXVALUE_heatVolMeas = 2047;
const int ciet_CONFIG_EHBS_MINVALUE_heatVolMeas = -2047;
const int ciet_CONFIG_EHBS_MAXVALUE_heatZeroVoltRefVolMeas = 2047;
const int ciet_CONFIG_EHBS_MINVALUE_heatZeroVoltRefVolMeas = -2047;
const int ciet_CONFIG_EHBS_MAXVALUE_heatZeroVoltRefVolMeasInVolts = 2047;
const int ciet_CONFIG_EHBS_MINVALUE_heatZeroVoltRefVolMeasInVolts = -2047;
const int ciet_CONFIG_EHBS_MAXVALUE_heatZeroHuitVoltRefVolMeas = 2047;
const int ciet_CONFIG_EHBS_MINVALUE_heatZeroHuitVoltRefVolMeas = -2047;
const int ciet_CONFIG_EHBS_MAXVALUE_heatZeroHuitVoltRefVolMeasInVolts = 63;
const int ciet_CONFIG_EHBS_MINVALUE_heatZeroHuitVoltRefVolMeasInVolts = -63;
const int ciet_CONFIG_EHBS_MAXVALUE_heatRelativeRefVol = 63;
const int ciet_CONFIG_EHBS_MINVALUE_heatRelativeRefVol = -63;
const int ciet_CONFIG_EHBS_MAXVALUE_HYSTERESIS = 7;
const int ciet_CONFIG_EHBS_MINVALUE_HYSTERESIS = 0;
const int ciet_CONFIG_EHBS_MAXVALUE_CYCLEPERIOD = 105;
const int ciet_CONFIG_EHBS_MINVALUE_CYCLEPERIOD = -105;
const int ciet_CONFIG_EHBS_MAXVALUE_suppliedVoltageCalc = 105;
const int ciet_CONFIG_EHBS_MINVALUE_suppliedVoltageCalc = -105;
const int ciet_CONFIG_EHBS_MAXVALUE_suppliedCurrentCalc = 105;
const int ciet_CONFIG_EHBS_MINVALUE_suppliedCurrentCalc = -105;
const int ciet_CONFIG_EHBS_MAXVALUE_thermocoupleVoltageOrPtResistanceCalc = 105;
const int ciet_CONFIG_EHBS_MINVALUE_thermocoupleVoltageOrPtResistanceCalc = -105;
const int ciet_CONFIG_EHBS_MAXVALUE_thCoupleTemperatureCalc = 105;
const int ciet_CONFIG_EHBS_MINVALUE_thCoupleTemperatureCalc = -10;
const int ciet_CONFIG_EHBS_MAXVALUE_thermocoupleOrPtTemperatureCalc = 105;
const int ciet_CONFIG_EHBS_MINVALUE_thermocoupleOrPtTemperatureCalc = -10;

const string ciet_CONFIG_EHBS_FORMAT_VOLT="V";
const string ciet_CONFIG_EHBS_FORMAT_MILIVOLT="mV";
const string ciet_CONFIG_EHBS_FORMAT_WATT="W";
const string ciet_CONFIG_EHBS_FORMAT_TIME="s";
const string ciet_CONFIG_EHBS_FORMAT_A="A";
const string ciet_CONFIG_EHBS_FORMAT_THCOUPLE="C";
const string ciet_CONFIG_EHBS_FORMAT_OHM="ohm";

const int ciet_EHBS_WIDGET_ANIMATION_MAXVALUE_powerCalc = 20;
const int ciet_EHBS_WIDGET_ANIMATION_MINVALUE_powerCalc = 5;

const float ciet_CONFIG_EHBS_TYPICAL_VALUE_heatZeroVoltRefVolMeas = 50;
const string ciet_CONFIG_EHBS_TYPICAL_VALUE_UNIT_heatZeroVoltRefVolMeas = "mV";
const float ciet_CONFIG_EHBS_FULLSCALE_heatZeroVoltRefVolMeas = 243.4;
const string ciet_CONFIG_EHBS_FULLSCALE_UNIT_heatZeroVoltRefVolMeas = "mV";
const int ciet_CONFIG_EHBS_FULLSCALE_MAXDATA_heatZeroVoltRefVolMeas = 4096;			// 12 bits  (4096)
const float ciet_CONFIG_EHBS_FULLSCALE_heatVolMeas = 243.4;
const string ciet_CONFIG_EHBS_FULLSCALE_UNIT_heatVolMeas = "mV";
const int ciet_CONFIG_EHBS_FULLSCALE_MAXDATA_heatVolMeas = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EHBS_25_500_TYPICAL_VALUE_heatZeroHuitVoltRefVolMeas = 50;
const string ciet_CONFIG_EHBS_25_500_TYPICAL_VALUE_UNIT_heatZeroHuitVoltRefVolMeas = "mV";
const float ciet_CONFIG_EHBS_25_500_FULLSCALE_heatZeroHuitVoltRefVolMeas = 243.4;
const string ciet_CONFIG_EHBS_25_500_FULLSCALE_UNIT_heatZeroHuitVoltRefVolMeas = "mV";
const int ciet_CONFIG_EHBS_25_500_FULLSCALE_MAXDATA_heatZeroHuitVoltRefVolMeas = 4096;		// 12 bits  (4096)
const float ciet_CONFIG_EHBS_25_500_FULLSCALE_heatZeroVoltRefVolMeasInVolts = 243.4;
const string ciet_CONFIG_EHBS_25_500_FULLSCALE_UNIT_heatZeroVoltRefVolMeasInVolts = "mV";
const int ciet_CONFIG_EHBS_25_500_FULLSCALE_MAXDATA_heatZeroVoltRefVolMeasInVolts = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EHBS_100_TYPICAL_VALUE_heatZeroHuitVoltRefVolMeas = 50;      
const string ciet_CONFIG_EHBS_100_TYPICAL_VALUE_UNIT_heatZeroHuitVoltRefVolMeas = "mV";
const float ciet_CONFIG_EHBS_100_FULLSCALE_heatZeroHuitVoltRefVolMeas = 243.4;
const string ciet_CONFIG_EHBS_100_FULLSCALE_UNIT_heatZeroHuitVoltRefVolMeas = "mV";
const int ciet_CONFIG_EHBS_100_FULLSCALE_MAXDATA_heatZeroHuitVoltRefVolMeas = 4096;			// 12 bits  (4096)
const float ciet_CONFIG_EHBS_100_FULLSCALE_heatZeroVoltRefVolMeasInVolts = 243.4;
const string ciet_CONFIG_EHBS_100_FULLSCALE_UNIT_heatZeroVoltRefVolMeasInVolts = "mV";
const int ciet_CONFIG_EHBS_100_FULLSCALE_MAXDATA_heatZeroVoltRefVolMeasInVolts = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EHBS_COMMON_TYPICAL_VALUE_heatZeroHuitVoltRefVolMeas = 50;      
const string ciet_CONFIG_EHBS_COMMON_TYPICAL_VALUE_UNIT_heatZeroHuitVoltRefVolMeas = "mV";
const float ciet_CONFIG_EHBS_COMMON_FULLSCALE_heatZeroHuitVoltRefVolMeas = 243.4;
const string ciet_CONFIG_EHBS_COMMON_FULLSCALE_UNIT_heatZeroHuitVoltRefVolMeas = "mV";
const int ciet_CONFIG_EHBS_COMMON_FULLSCALE_MAXDATA_heatZeroHuitVoltRefVolMeas = 4096;			// 12 bits  (4096)
const float ciet_CONFIG_EHBS_COMMON_FULLSCALE_heatZeroVoltRefVolMeasInVolts = 243.4;
const string ciet_CONFIG_EHBS_COMMON_FULLSCALE_UNIT_heatZeroVoltRefVolMeasInVolts = "mV";
const int ciet_CONFIG_EHBS_COMMON_FULLSCALE_MAXDATA_heatZeroVoltRefVolMeasInVolts = 4096;			// 12 bits  (4096)

const float ciet_CONFIG_EHBS_TYPICAL_VALUE_heatRelativeRefVol = 27.7;
const string ciet_CONFIG_EHBS_TYPICAL_VALUE_UNIT_heatRelativeRefVol = "mV";
const float ciet_CONFIG_EHBS_FULLSCALE_heatRelativeRefVol = 93.2;
const string ciet_CONFIG_EHBS_FULLSCALE_UNIT_heatRelativeRefVol = "mV";
const int ciet_CONFIG_EHBS_FULLSCALE_MAXDATA_heatRelativeRefVol = 128;			// 7 bits  (128)
const float ciet_CONFIG_EHBS_FULLSCALE_heatZeroHuitVoltRefVolMeasInVolts = 93.2;
const string ciet_CONFIG_EHBS_FULLSCALE_UNIT_heatZeroHuitVoltRefVolMeasInVolts = "mV";
const int ciet_CONFIG_EHBS_FULLSCALE_MAXDATA_heatZeroHuitVoltRefVolMeasInVolts = 128;			// 7 bits  (128)

const string ciet_EHBS_WIDGET_ANIMATION_HEATER_OVER_TEMPERATURE_LETTER = "H";
const string ciet_EHBS_WIDGET_ANIMATION_CARD_OVER_TEMPERATURE_LETTER = "C";
const string ciet_EHBS_WIDGET_ANIMATION_HEATER_AND_CARD_OVER_TEMPERATURE_LETTER = "HC";

const string ciet_EHBS_TYPE_25W = "25w";
const string ciet_EHBS_TYPE_100W = "100w";
const string ciet_EHBS_TYPE_500W_25W = "500w+25w";
const string ciet_EHBS_TYPE_500W = "500w";

const int ciet_EHBS_ON_OFF_STATUS_BIT = 3;
const int ciet_EHBS_ON_OFF_FORCED_BIT = 9;
const int ciet_EHBS_ENABLE_DISABLE_STATUS_BIT = 4;
const int ciet_EHBS_ENABLE_DISABLE_FORCED_BIT = 10;
const int ciet_EHBS_CARD_PROTECTION_BIT = 4;
const int ciet_EHBS_CARD_OVER_TEMP_BIT = 8;
const int ciet_EHBS_HEATER_OVER_TEMP_BIT = 6;
const int ciet_EHBS_WATCHDOG_BIT = 2;
const int ciet_EHBS_POWER_CYCLE_BIT = 5;
const int ciet_EHBS_SENSOR_STATUS2_THERMISTOR_MODE = 7;


/*const unsigned UN_CONFIG_CRYOGTW_EHBS_ARCHIVE_ACTIVE = 17;
const unsigned UN_CONFIG_CRYOGTW_EHBS_LENGTH = 18;*/


//---------------------------------------------------------------------------------------------------------------------------------------

// constants for DI device
	
const unsigned ciet_CONFIG_DI_LENGTH = 3;
const unsigned ciet_CONFIG_DI_CMWDEVICE = 1;
const unsigned ciet_CONFIG_DI_ARCHIVEACTIVE = 2;
const unsigned ciet_CONFIG_DI_ARCHIVETIMEFILTER = 3;

const unsigned UN_CONFIG_CRYOGTW_DI_ARCHIVE_ACTIVE = 2;
const unsigned UN_CONFIG_CRYOGTW_DI_LENGTH = 3;
//---------------------------------------------------------------------------------------------------------------------------------------
// constants for CryoSgtPLC device

const unsigned ciet_CONFIG_CRYOSGTPLC_LENGTH = 3;
const unsigned ciet_CONFIG_CRYOSGTPLC_CMWDEVICE = 1;
const unsigned ciet_CONFIG_CRYOSGTPLC_ARCHIVEACTIVE = 2;
const unsigned ciet_CONFIG_CRYOSGTPLC_ARCHIVETIMEFILTER = 3;

const unsigned UN_CONFIG_CRYOGTW_CRYOSGTPLC_ARCHIVE_ACTIVE = 2;
const unsigned UN_CONFIG_CRYOGTW_CRYOSGTPLC_LENGTH = 3;
//---------------------------------------------------------------------------------------------------------------------------------------

// constants for WFIPSegment device
	
const unsigned ciet_CONFIG_WFIPSegment_LENGTH = 4;
const unsigned ciet_CONFIG_WFIPSegment_FIPPOSITION = 1;
const unsigned ciet_CONFIG_WFIPSegment_CMWDEVICE = 2;
const unsigned ciet_CONFIG_WFIPSegment_ARCHIVEACTIVE = 3;
const unsigned ciet_CONFIG_WFIPSegment_ARCHIVETIMEFILTER = 4;

const unsigned UN_CONFIG_CRYOGTW_WFIPSegment_ARCHIVE_ACTIVE = 3;
const unsigned UN_CONFIG_CRYOGTW_WFIPSegment_LENGTH = 4;


//---------------------------------------------------------------------------------------------------------------------------------------
// constants to get FIP infos
/*const unsigned ciet_PARAMETER_AGENTNAME = 1;
const unsigned ciet_PARAMETER_CHANNEL_NUMBER = 2;*/

const unsigned ciet_PARAMETER_BUS = 1;
const unsigned ciet_PARAMETER_GTWNAME = 2;
const unsigned ciet_PARAMETER_AGENTNUMBER = 3;
const string ciet_PARAMETER_AGENTNAME = 4;
const string ciet_PARAMETER_CHANNELNUMBER = 5;
/*const unsigned ciet_PARAMETER_AGENT_SAMELEVEL = 4;
const unsigned ciet_PARAMETER_AGENT_OPPOSITELEVEL = 5;*/

//---------------------------------------------------------------------------------------------------------------------------------------
